require "net/http"
require "net/https"
require "json"

module Lableb
  class Client
    def createRequest(url, headers)
      http = Net::HTTP.new(url.host, url.port)
      headers.each do | key, value |
        req[key] = value
      end
      http.use_ssl = true
      return http
    end

    def getJSON(url, qs = {}, headers = {})
      uri = URI("#{url}?#{self.buildQueryString(qs)}")
      http = self.createRequest(uri, headers)
      req = Net::HTTP::Get.new(uri)
      response = http.request(req)
      return response
    end

    def postJSON(url, body = {}, qs = {}, headers = {})
      uri = URI("#{url}?#{self.buildQueryString(qs)}")
      http = self.createRequest(uri, headers)
      req = Net::HTTP::Post.new(uri, { 'Content-Type': 'application/json' })
      req.body = body.to_json
      response = http.request(req)
      return response
    end

    def deleteJSON(url, qs = {}, headers = {})
      uri = URI("#{url}?#{self.buildQueryString(qs)}")
      http = self.createRequest(uri, headers)
      req = Net::HTTP::Delete.new(uri)
      response = http.request(req)
      return response
    end

    def buildQueryString(params)
      res = []
      params.each do | key, value |
        if value.kind_of? Array
          res.push(value.map{|el| "#{key}=#{el}"})
        elsif value.is_a? Hash
          value.each do | key2, val2 |
            temp = {}
            if val2.is_a? String
              temp[key] = "#{key2}:\"#{val2}\""
            elsif val2.is_a? Array
              temp[key] = val2.map{|el| "#{key2}:\"#{el}\""}
            end
            res.push(buildQueryString(temp))
          end
        else
          res.push("#{key}=#{value.to_s}")
        end
      end
      res.join("&")
    end
  end
end